from random import randint, seed

def choose3(N): return N*(N-1)*(N-2)//6

def gen_random(N, maxv=10**12):
    A = set()
    while len(A) < N: A.add( randint(1,maxv) )
    return sorted(list(A))

def gen_biglast(N):
    A = set()
    male = randint(2,10)
    while len(A) < male: A.add( randint(1,10**11) )
    while len(A) < N: A.add( randint(10**12 - 10**10, 10**12) )
    return sorted(list(A))

def save(fname,K,seq):
    f = open(fname,'w')
    f.write('{} {}\n{}\n'.format(len(seq),K,' '.join(str(x) for x in seq)))
    f.close()

save('00a.in',4,[1,2,3,4,5])
save('00b.in',4,[1,10,100,1000,10000])

sizes = [ None, 10, 100, 500, 1500, 4000, 7000, 42000, 63000, 80000, 100000 ]

for t in range(1,11):
    seed(t)
    N = sizes[t]

    maxr = min(10**6,choose3(N))
    if t <= 5:
        minr = 1
    else:
        minr = max(1,maxr//2)

    K = randint(minr,maxr)
    save('{:02d}a.in'.format(t),K,gen_random(N))

    K = randint(minr,maxr)
    save('{:02d}b.in'.format(t),K,gen_biglast(N))

    K = randint(minr,maxr)
    save('{:02d}c.in'.format(t),K,gen_random(N,5*N))

